/* Huffman coding
 *
 * Main file for testing
 * 15-122 Principles of Imperative Computation, Fall 2012
 */

#include <stdlib.h>
#include <stdbool.h>
#include <stdio.h>
#include <string.h>
#include <assert.h>

#include "freqtable.h"
#include "huffman.h"

int main () {
  freqtable F = read_freqtable("inputs/morefreecoffee.txt");
  // freqtable F = read_freqtable("inputs/english.txt");
  // freqtable F = read_freqtable("inputs/bogus.txt");
  // freqtable F = read_freqtable("inputs/singleton.txt");
  htree *H = build_htree(F);
  char *msg = "roomforcreme";
  printf("%s\n", msg);

  // char *coded_msg = encode(H, "roomforcreme");
  printf("Warning: coded message may be wrong, "
         "depending on your Huffman tree.\n");
  printf("Replace with an encoding obtained from your C0 implementation\n");
  printf("or port encode() for extra credit.\n");

  char *coded_msg = "10011011010111111101001010100010110";
  printf("%s\n", coded_msg);

  char *decoded_msg = decode(H, coded_msg);
  printf("%s\n", decoded_msg);

  /* check roundtrip msg -> coded_msg -> decoded_msg */
  assert(strcmp(msg, decoded_msg) == 0);

  /* free allocated data structures */
  freqtable_free(F);
  htree_free(H);
  // free(coded_msg);  /* don't free string constant */
  free(decoded_msg);

  return 0;
}
